version: "3.5"
services:
        authentication:
                image: mymobiconf/authservice
                build: # build local Dockerfile
                        context: .
                        dockerfile: Auth.Dockerfile
                restart: on-failure # restart if this container fails
                deploy: # on swarm mode...
                        replicas: 6 # starts 6 replicas of this container
                        restart_policy:
                                condition: on-failure # restart if this container fails
                                delay: 5s # wait 5 seconds until restarting process
                        update_config: # on update...
                                parallelism: 2 # updates two replicas at a time
                                failure_action: rollback # if deploy fails, rollback
                                monitor: 1s # wait 1 second for deploy failures
                                order: start-first # start the new version b4 closing the old one
#                        endpoint_mode: dnsrr # setup DNS round-robin
                networks: # connect to cassandra
                        - cassandra_net
                depends_on: # wait cassandra starts
                        - cassandra
                ports: # expose port 3000 to host port 82
                        - "82:3000"

        cassandra-migration:
                image: mymobiconf/cassandra-migration
                build: # build local Dockerfile
                        context: .
                        dockerfile: CassandraMigration.Dockerfile
                restart: "no"
                deploy:
                        restart_policy: 
                                condition: none
                depends_on: # wait cassandra starts
                        - cassandra
                networks: # connect to cassandra
                        - cassandra_net

        cassandra:
                image: cassandra:3 # fetch cassandra image
                networks: # connect to loopback
                        - cassandra_net
                restart: on-failure # restart if this container fails
                deploy: # on swarm mode...
                        placement:
                                constraints: [node.role == manager]
                ports: # expose externally some ports
                        - "8888:8888"
                        - "7000:7000"
                        - "7001:7001"
                        - "7199:7199"
                        - "9042:9042"
                        - "9160:9160"
                        - "9404:9404"
                volumes: # makes cassandra data persistent between updates
                        - db-volume:/var/lib/cassandra
                        - ./db-schema:/docker-entrypoint-initdb.d/
networks:
        cassandra_net: # "auth service replicas <-> cassandra <-> migration" network
        services_net: # "auth service replicas <-> other services replica" network
                external: true
volumes:
        db-volume: # cassandra data persistence volume
